Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListView1: TListView;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private

  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}


Procedure ListViewSelectItemIndex(Const Listview: TListView; aIndex: integer);
Var
  Idx: Integer;
Begin
  If aindex >= Listview.Items.Count Then exit;
  If Not assigned(Listview.TopItem) Then exit;
  form1.caption := 'Index: ' + inttostr(aIndex + 1); // In der Caption zeigen welcher Eintrag angewählt wurde
  Listview.BeginUpdate;
  Listview.ClearSelection;

  // So hinscrollen, dass man das man den aIndex uberhaupt sehen kann
  Listview.Items[aIndex].MakeVisible(False);

  // Der Versuch den ausgewählten Eintrag ungefähr "mittig" in der Listview an zu zeigen
  Idx := Listview.TopItem.Index + (Listview.VisibleRowCount Div 2);
  If aIndex <> Idx Then
    Idx := aIndex + (aIndex - Idx);
  If (Idx < 0) Then
    Idx := 0;
  If (Idx >= Listview.Items.Count) Then
    Idx := Listview.Items.Count - 1;
  Listview.Items[Idx].MakeVisible(False);

  // Der Versuch den Eintrag auch so zu selektiern dass dieser
  // 1. Blau hinterlegt ist
  // 2. Wenn der User die Pfeiltasten verwendet von diesem auch weiter "navigiert" wird
  Listview.Items[aIndex].Selected := true; // Das macht den Eintrag "blau"
  Listview.ItemIndex := aIndex; // Das hier scheint nichts zu bewirken
  Listview.Selected := Listview.Items[aIndex]; // Das hier scheint nichts zu bewirken

  Listview.EndUpdate;
  // Dem Listview den "Focus" geben, damit der User nicht "rein" clicken muss
  Listview.SetFocus;
End;

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Var
  i: Integer;
  item: TListItem;
Begin
  For i := 1 To 100 Do Begin
    item := ListView1.Items.Add;
    item.Caption := format('%0.3d', [i]);
    item.SubItems.add('Blub');
    item.SubItems.add('Blib');
  End;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  // Jump to mid
  ListViewSelectItemIndex(ListView1, ListView1.Items.Count Div 2);
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  // Jump to first
  ListViewSelectItemIndex(ListView1, 0);
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  // Jump to last
  ListViewSelectItemIndex(ListView1, ListView1.Items.Count - 1);
End;

End.

